package com.keystar.plane.inspection.service;

import com.drew.imaging.jpeg.JpegProcessingException;
import com.fasterxml.jackson.core.JsonProcessingException;
import com.keystar.plane.inspection.bo.NewFileBo;
import com.keystar.plane.inspection.bo.PhotoMqttMessageBo;

import java.io.File;
import java.io.IOException;
import java.text.ParseException;
import java.util.List;

public interface MqttService {

    /**
     *  发送Mqtt给图像识别
     **/
    void sendMqtt(List<PhotoMqttMessageBo> messageBos) throws JsonProcessingException;

    /**
     *  发送多条图片道图像识别
     **/
    void sendPhotos(String path, String type) throws JsonProcessingException;

    /**
     *  发送最新架次的图片目录给图像识别
     **/
    void sendPhotoFile(String path, String type) throws JsonProcessingException;

    /**
     *  发送最新任务的红外图片给图像识别
     **/
    void sendPhotoMqtt() throws IOException, JpegProcessingException, ParseException;

    /**
     *  发送指定文件下的图片给图像识别
     **/
    File[] sendPhotoMatt(NewFileBo newFile) throws JpegProcessingException, IOException, ParseException;

}
