package com.keystar.plane.inspection.service;

import com.drew.imaging.jpeg.JpegProcessingException;
import com.keystar.plane.inspection.bo.Location;
import com.keystar.plane.inspection.bo.PvNameBo;
import com.keystar.plane.inspection.entity.PlanePhotoEntity;
import com.keystar.plane.inspection.vo.PhotoMessageVo;
import com.keystar.plane.inspection.vo.PhotoResultVo;
import com.keystar.plane.inspection.vo.PlanePhotoVo;

import java.io.IOException;

public interface PhotoService {

    /**
     *  通过图片判断是哪个光伏区的光伏板
     **/
    PlanePhotoVo queryPhoto(String filePath) throws IOException, JpegProcessingException;

    /**
     *  通过组串名字获取对应的图片和识别结果
     **/
    PhotoResultVo getPhotoMsg(PvNameBo pvNameBo);

    /**
     *  通过图片和异常坐标判断异常是在那个组串上
     **/
    PlanePhotoVo queryPhoto(PhotoMessageVo photoMessage, Location location) throws IOException, JpegProcessingException;

    /**
     *  将minio图片画框并转成base64
     **/
    String addBorderToBase64(PlanePhotoEntity photo) throws IOException;

}
