package com.keystar.plane.inspection.service.impl;


import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.keystar.plane.inspection.bo.DateBo;
import com.keystar.plane.inspection.entity.PlaneTaskEntity;
import com.keystar.plane.inspection.mapper.PlaneTaskMapper;
import com.keystar.plane.inspection.service.PlaneTaskService;
import com.keystar.plane.inspection.vo.PlaneTaskVo;
import lombok.RequiredArgsConstructor;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
@RequiredArgsConstructor
public class PlaneTaskServiceImpl extends ServiceImpl<PlaneTaskMapper, PlaneTaskEntity> implements PlaneTaskService{

    @Autowired
    PlaneTaskMapper planeTaskMapper;

    /**
     * 插入任务
     **/
    @Override
    public void insertTask(PlaneTaskEntity planeTaskEntity) {
        planeTaskMapper.insert(planeTaskEntity);
    }


    /**
     *  查询全部任务
     **/
    @Override
    public int queryAllTask() {
        return planeTaskMapper.queryAllTask();
    }

    /**
     *  查询完成的任务
     **/
    @Override
    public int queryFinishedTask(DateBo dateBo) {
        List<PlaneTaskVo> planeTaskVos = planeTaskMapper.queryFinishedTask(dateBo);
        int count = 0;
        for (PlaneTaskVo planeTaskVo : planeTaskVos){
            if (planeTaskVo.getNumRecords() != 0){
                count += 1;
            }
        }
        return count;
    }


}
